<template>
  <div class='p-2'>
    <transition :enter-active-class='proxy?.animate.searchAnimate.enter'
                :leave-active-class='proxy?.animate.searchAnimate.leave'>
      <div v-show='showSearch' class='mb-[10px]'>
        <el-card shadow='hover'>
          <el-form ref='queryFormRef' :model='queryParams' :inline='true'>
            <el-form-item label='设备模型名称' prop='deviceModeName' label-width='100px'>
              <el-input v-model='queryParams.deviceModeName' placeholder='请输入设备模型名称' clearable
                        @keyup.enter='handleQuery' />
            </el-form-item>
            <el-form-item label='设备模型状态' prop='deviceModeStatus' label-width='100px'>
              <el-select v-model='queryParams.deviceModeStatus' placeholder='请选择设备模型状态' clearable>
                <el-option v-for='dict in dms_device_mode_status' :key='dict.value' :label='dict.label'
                           :value='dict.value' />
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button type='primary' icon='Search' @click='handleQuery'>搜索</el-button>
              <el-button icon='Refresh' @click='resetQuery'>重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow='never'>
      <template #header>
        <el-row :gutter='10' class='mb8'>
          <el-col :span='1.5'>
            <el-button type='primary' plain icon='Plus' @click='handleAdd' v-hasPermi="['dms:deviceMode:add']">新增
            </el-button>
          </el-col>
          <el-col :span='1.5'>
            <el-button type='success' plain icon='Edit' :disabled='single' @click='handleUpdate()'
                       v-hasPermi="['dms:deviceMode:edit']">修改
            </el-button>
          </el-col>
          <el-col :span='1.5'>
            <el-button type='danger' plain icon='Delete' :disabled='multiple' @click='handleDelete()'
                       v-hasPermi="['dms:deviceMode:remove']">删除
            </el-button>
          </el-col>
          <el-col :span='1.5'>
            <el-button type='warning' plain icon='Download' @click='handleExport'
                       v-hasPermi="['dms:deviceMode:export']">导出
            </el-button>
          </el-col>
          <right-toolbar v-model:showSearch='showSearch' :columns='columns' :search='true'
                         @queryTable='getList'></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading='loading' :data='deviceModeList' @selection-change='handleSelectionChange'>
        <el-table-column type='selection' width='55' align='center' />
        <el-table-column label='设备模型ID' align='center' prop='deviceModeId' v-if='columns[0].visible' />
        <el-table-column label='设备模型名称' align='center' prop='deviceModeName' v-if='columns[1].visible' />
        <el-table-column label='设备模型图片' align='center' prop='deviceModePic' v-if='columns[4].visible'>
          <template #default='scope'>
            <ImagePreview
              v-if='checkFileSuffix(scope.row.deviceModePic)'
              :width='100'
              :height='100'
              :src='scope.row.deviceModePic'
              :preview-src-list='[scope.row.deviceModePic]'
            />
            <span v-else v-text='scope.row.deviceModePic' />
          </template>
        </el-table-column>
        <el-table-column label='场景描述' align='center' prop='remark' v-if='columns[5].visible' />
        <el-table-column label='设备模型状态' align='center' prop='deviceModeStatus' v-if='columns[3].visible'>
          <template #default='scope'>
            <dict-tag :options='dms_device_mode_status' :value='scope.row.deviceModeStatus' />
          </template>
        </el-table-column>
        <el-table-column label='操作' align='center' class-name='small-padding fixed-width'>
          <template #default='scope'>
            <el-button link type='primary' @click='handleUpdate(scope.row)'
                       v-hasPermi="['dms:deviceMode:edit']">模型功能
            </el-button>
            <!--            <el-tooltip content='删除' placement='top'>-->
            <!--              <el-button link type='primary' icon='Delete' @click='handleDelete(scope.row)'-->
            <!--                         v-hasPermi="['dms:deviceMode:remove']"></el-button>-->
            <!--            </el-tooltip>-->
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show='total > 0' :total='total' v-model:page='queryParams.pageNum'
                  v-model:limit='queryParams.pageSize' @pagination='getList' />
    </el-card>
    <!-- 添加或修改设备模型对话框 -->
    <el-dialog :title='dialog.title' v-model='dialog.visible' width='500px' append-to-body>
      <el-form ref='deviceModeFormRef' :model='form' :rules='rules' label-width='130px'>
        <el-form-item label='设备模型名称' prop='deviceModeName'>
          <el-input v-model='form.deviceModeName' placeholder='请输入设备模型名称' />
        </el-form-item>
        <!--        <el-form-item label='设备模型状态' prop='deviceModeStatus'>-->
        <!--          <el-radio-group v-model='form.deviceModeStatus'>-->
        <!--            <el-radio-->
        <!--              v-for='dict in dms_device_mode_status'-->
        <!--              :key='dict.value'-->
        <!--              :value='dict.value'-->
        <!--            >{{ dict.label }}-->
        <!--            </el-radio>-->
        <!--          </el-radio-group>-->
        <!--        </el-form-item>-->
        <el-form-item label='设备模型图片' prop='ossId'>
          <imageUpload v-model='form.file' />
        </el-form-item>
        <el-form-item label='场景描述' prop='remark'>
          <el-input v-model='form.remark' placeholder='请输入场景描述' />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class='dialog-footer'>
          <el-button :loading='buttonLoading' type='primary' @click='submitForm'>确 定</el-button>
          <el-button @click='cancel'>取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name='DeviceMode' lang='ts'>
import { listDeviceMode, getDeviceMode, delDeviceMode, addDeviceMode, updateDeviceMode } from '@/api/dms/deviceMode';
import { DeviceModeVO, DeviceModeQuery, DeviceModeForm } from '@/api/dms/deviceMode/types';
import imageUpload from '@/components/ImageUpload/index.vue';
import ImagePreview from '@/components/ImagePreview/index.vue';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { dms_device_mode_status } = toRefs<any>(proxy?.useDict('dms_device_mode_status'));

const deviceModeList = ref<DeviceModeVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const deviceModeFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

// 列显隐信息
const columns = ref<FieldOption[]>([
  { key: 0, label: `设备模型ID`, visible: false },
  { key: 1, label: `设备模型名称`, visible: true },
  { key: 2, label: `租户编号`, visible: true },
  { key: 3, label: `设备模型状态`, visible: true },
  { key: 4, label: `设备模型图片`, visible: true },
  { key: 5, label: `场景描述`, visible: true },
  { key: 6, label: `创建部门`, visible: false },
  { key: 7, label: `创建人`, visible: false },
  { key: 8, label: `创建时间`, visible: false },
  { key: 9, label: `更新人`, visible: false },
  { key: 10, label: `更新时间`, visible: false }
]);

const initFormData: DeviceModeForm = {
  deviceModeId: undefined,
  deviceModeName: undefined,
  deviceModeStatus: '1',
  deviceModePic: undefined,
  ossId: undefined,
  remark: undefined
};
const data = reactive<PageData<DeviceModeForm, DeviceModeQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    deviceModeId: undefined,
    deviceModeName: undefined,
    deviceModeStatus: undefined,
    deviceModePic: undefined,
    params: {}
  },
  rules: {
    deviceModeName: [
      { required: true, message: '设备模型名称不能为空', trigger: 'blur' }
    ]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备模型列表 */
const getList = async () => {
  loading.value = true;
  const res = await listDeviceMode(queryParams.value);
  deviceModeList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 检查文件后缀是否为图片 */
function checkFileSuffix(fileSuffix: string | string[]) {
  if (!fileSuffix) return false;
  const arr = ['.png', '.jpg', '.jpeg', '.gif'];
  const suffix = typeof fileSuffix === 'string' ? fileSuffix.toLowerCase() : '';
  return arr.some(item => suffix.endsWith(item));
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  deviceModeFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: DeviceModeVO[]) => {
  ids.value = selection.map(item => item.deviceModeId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加设备模型';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: DeviceModeVO) => {
  reset();
  const _deviceModeId = row?.deviceModeId || ids.value[0];
  if (row?.deviceModeId !== undefined) {
    proxy?.$tab.openPage('/dms/deviceMode/mode-edit/index/' + _deviceModeId, '修改设备模型[' + row?.deviceModeName + ']', { deviceModeId: _deviceModeId });
    return;
  }
  const res = await getDeviceMode(_deviceModeId);
  if (res.data.ossId != null && res.data.ossId != '') {
    const ossIdArray = res.data.ossId.split(',');
    const urlArray = res.data.deviceModePic.split(',');
    res.data.file = ossIdArray.map((ossId, index) => ({
      ossId: ossId.trim(),
      url: urlArray[index] ? urlArray[index].trim() : ''
    }));
  }
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改设备模型';
};

/** 提交按钮 */
const submitForm = () => {
  deviceModeFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.file != null && form.value.file != '') {
        form.value.ossId = form.value.file.map(e => e.ossId).join(',');
        form.value.deviceModePic = form.value.file.map(e => e.url).join(',');
      } else if (form.value.file == '') {
        form.value.ossId = '';
        form.value.deviceModePic = '';
      }
      if (form.value.deviceModeId) {
        await updateDeviceMode(form.value).finally(() => buttonLoading.value = false);
      } else {
        await addDeviceMode(form.value).finally(() => buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: DeviceModeVO) => {
  const _deviceModeIds = row?.deviceModeId || ids.value;
  await proxy?.$modal.confirm('是否确认删除设备模型编号为"' + _deviceModeIds + '"的数据项？').finally(() => loading.value = false);
  await delDeviceMode(_deviceModeIds);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('dms/deviceMode/export', {
    ...queryParams.value
  }, `deviceMode_${new Date().getTime()}.xlsx`);
};

onMounted(() => {
  getList();
});
</script>
